#ifndef UTILITY_H_
#define UTILITY_H_

#include <string>
#include <mpirxx.h>

using namespace std;

/**
 * C++ API: Compute the 4th root of a multiple-precision number x.
 * @param root4 the computed multiple-precision 4th root of x.
 * @param x the multiple-precision number.
 */
mpf_class& root4(mpf_class& root4, const mpf_class& x);

/**
 * C++ API: Compute the 4th power of a multiple-precision number x.
 * @param xxxx the computed multiple-precision 4th power of x.
 * @param x the multiple-precision number.
 */
mpf_class& power4(mpf_class& xxxx, const mpf_class& x);

/**
 * Print the decimal places of a multiple-precision number after it's
 * been converted to a string, and the compute time in nanoseconds.
 * @param s the string to print.
 */
void print(char *s, long ns);

/**
 * Convert a long integer to a string with commas.
 * @param i the integer.
 * @return the string with commas.
 */
string commafy(const long i);

#endif /* UTILITY_H_ */
